<?php

/**
 * 01/06/2015
 * @author Francis
 */

namespace MyMeals\Services;

use MyMeals\Libraries\PHPMailer;

class SMTP {

    private $SMTPAuth    = true;
    private $IsHTML      = true;
    private $Host        = "smtp.teknisa.com";
    private $Username    = "app@tecfood.com";
    private $Password    = "@AppTecFood2015";
    private $From        = "no-reply@teknisa.com";
    private $FromName    = "TecFood MyMeals";
    private $NmAddress   = "";
    private $Subject     = "Alteração de comensais";
    private $Attachments = array();

    public function __construct(array $params = array()) {
        if (!empty($params)) {
            $this->Host     = $params['host'];
            $this->Username = $params['username'];
            $this->Password = $params['password'];
        }
    }

    public function sendMail($message, $address) {
        $mail = new PHPMailer;
        $mail->CharSet  = 'UTF-8';
        $mail->IsHTML($this->IsHTML);
        $mail->isSMTP();                   // Set mailer to use SMTP
        $mail->Host     = $this->Host;     // Specify main and backup SMTP servers
        $mail->SMTPAuth = $this->SMTPAuth; // Enable SMTP authentication
        $mail->Username = $this->Username; // SMTP username
        $mail->Password = $this->Password; // SMTP password
        $mail->From     = $this->From;
        $mail->FromName = $this->FromName;
        $mail->Subject  = $this->Subject;
        $mail->Body     = $message;

        if (is_array($address)) {
            foreach ($address as $to) {
                $mail->addAddress($to, $to); // Add multiple recipients
            }
        }
        else {
            $mail->addAddress($address, $this->NmAddress); // Add a recipient
        }

        foreach ($this->Attachments as $attachment) { // Add all attachments
            $mail->addAttachment($attachment["path"], $attachment["name"], $attachment["encoding"], $attachment["type"], $attachment["disposition"]);
        }

        $mail->send();
    }

    public function setHost($Host) {
        $this->Host = $Host;
    }

    public function setSMTPAuth($SMTPAuth) {
        $this->SMTPAuth = $SMTPAuth;
    }

    public function setUsername($Username) {
        $this->Username = $Username;
    }

    public function setIsHTML($IsHTML) {
        $this->IsHTML = $IsHTML;
    }

    public function setPassword($Password) {
        $this->Password = $Password;
    }

    public function setFrom($From) {
        $this->From = $From;
    }

    public function setFromName($FromName) {
        $this->FromName = $FromName;
    }

    public function setNmAddress($NmAddress) {
        $this->NmAddress = $NmAddress;
    }

    public function setSubject($Subject) {
        $this->Subject = $Subject;
    }

    public function addAttachment($path, $name = '', $encoding = 'base64', $type = '', $disposition = 'attachment') {
        $this->Attachments[] = array(
            "path"        => $path,
            "name"        => $name,
            "encoding"    => $encoding,
            "type"        => $type,
            "disposition" => $disposition
        );
    }

}